//============================================================================
//	axpad03w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 1998/08/07
//
//============================================================================

unit axpad03w;

interface

uses
	Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
	AD03_SUCCESS                  = 0;	// Successfully proccessed
	AD03_ERR_SYSTEM               = 1;	// Call GetLastError()
	AD03_ERR_NO_DEVICE            = 2;	// No card
	AD03_ERR_IN_USE               = 3;	// Device is in use
	AD03_ERR_INVALID_SOCKET       = 4;	// Invalid logical SOCKET
	AD03_ERR_RESOURCE             = 5;	// Resource exhaustion
	AD03_ERR_ILLEGAL_FUNCTION_CALL= 6;	// Illegal Function Call
	AD03_ERR_INVALID_ARGUMENT     = 7;	// Invalid argument
	AD03_ERR_NUMDATA              = 8;	// Invalid Number of Data
	AD03_ERR_INTERNAL             = 9;	// Internal Error
	AD03_ERR_WRAPDLL 							= DWORD(-1);	// ׯ߰֐װ
//-------------------------------------
// ð
//-------------------------------------
	AD03_STS_SAMPLING          		= $1;	// TvO
	AD03_STS_BUFF_FULL         		= $2;	// obt@(FIFO)t
	AD03_STS_HOLDOFF_ERROR     		= $4;	// HOLD OFF G[
//-------------------------------------
// ү
//-------------------------------------
	WM_BUFF_FULL                  = 0;	// obt@(FIFO)t
	WM_CARD_REMOVAL               = 1;	// J[h
//-------------------------------------
// ̑萔
//-------------------------------------
 	AD03_MAX_SOCKETS							= 16;							// T|[g\Pbg
	AD03_NUM_CHANNELS             = 2;							// `l
	AD03_BUFF_PCH_MAX 						= 4096;						// P`l̃obt@TCY
	AD03_DEVICE_ID    						= $c0054103;			// foCXhc
 	AD03_SOCKET_AUTO							= WORD(not 0);		// foCX݂Ă_\PbgT
	AD03_DLL_NAME 								= 'axpad03.dll';	// DLĻٖ
//-------------------------------------
// ؿ\
//-------------------------------------
	AD03_NMAX_MEM	=	9;
	AD03_NMAX_IO	= 20;
	AD03_NMAX_IRQ	=	7;
	AD03_NMAX_DMA	=	7;

type
	TAD03RESOURCE = record
		dwNumMemWindows:															DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. AD03_NMAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. AD03_NMAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. AD03_NMAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																	DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. AD03_NMAX_IO]	 of	DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. AD03_NMAX_IO]	 of	DWORD;	// I/O߰Ē
		dwNumIRQs:																		DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. AD03_NMAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:		array [1 .. AD03_NMAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:																		DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. AD03_NMAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. AD03_NMAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] 						 of	DWORD;	// \(gp)
	end;
	PAD03RESOURCE = ^TAD03RESOURCE;
//-------------------------------------
// ݸҰ\
//-------------------------------------
	TAD03MODE = record
		dwSampleTime:		DWORD;
		dwTrigMode:			DWORD;
		dwTrigSource:		DWORD;
		dwTrigSlope:		DWORD;
		dwTrigLevel:		DWORD;
		dwTrigPosition:	DWORD;
		dwTrigDelay:		DWORD;
		dwTrigHoldOff:	DWORD;
	end;
  PAD03MODE = ^TAD03MODE;
//-------------------------------------
// ݸޯ̧z^
//-------------------------------------
	TAD03SMPLBUFF = array [1..(AD03_NUM_CHANNELS * AD03_BUFF_PCH_MAX)] of WORD;
	PAD03SMPLBUFF = ^TAD03SMPLBUFF;
//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Ad03wDllOpen: Boolean;
// DLL ۰
function Ad03wDllClose: Boolean;
// DLL,޲ײްްޮݔԍ擾
function Ad03wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
// foCX̎gp錾
function Ad03wCreate(var pwLogSocket:WORD; hWnd:THandle; uWMBase:Integer): Boolean;
// foCXJ
function Ad03wClose(wLogSocket:WORD): Boolean;
// ؿ擾
function Ad03wGetResource(wLogSocket:WORD; pResInfo:PAD03RESOURCE): Boolean;
// ݸޓӰނ̐ݒ
function Ad03wSetMode(wLogSocket:WORD; pMode:PAD03MODE): Boolean;
// ݸނ̽
function Ad03wStartSampling(wLogSocket:WORD): Boolean;
// ݸނ̽į
function Ad03wStopSampling(wLogSocket:WORD): Boolean;
// ݸ޽ð̎擾
function Ad03wGetSamplingStatus(wLogSocket:WORD; var pcwNumData:DWORD; var pdwStatus:DWORD): Boolean;
// ݸް̎擾
function Ad03wGetData(wLogSocket:WORD; cwNumData:DWORD; pwData:PAD03SMPLBUFF): Boolean;
// AXP-AD03̴װ
function Ad03wGetLastError(wLogSocket:WORD): DWORD;
//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TAd03GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
	TAd03Create = function(var pwLogSocket:WORD; hWnd:THandle; uWMBase:Integer): BOOL; stdcall;
	TAd03Close = function(wLogSocket:WORD): BOOL; stdcall;
	TAd03GetResource = function(wLogSocket:WORD; pResInfo:PAD03RESOURCE): BOOL; stdcall;
	TAd03SetMode = function(wLogSocket:WORD; pMode:PAD03MODE): BOOL; stdcall;
	TAd03StartSampling = function(wLogSocket:WORD): BOOL; stdcall;
	TAd03StopSampling = function(wLogSocket:WORD): BOOL; stdcall;
	TAd03GetSamplingStatus = function(wLogSocket:WORD; var pcwNumData:DWORD; var pdwStatus:DWORD): BOOL; stdcall;
	TAd03GetData = function(wLogSocket:WORD; cwNumData:DWORD; pwData:PAD03SMPLBUFF): BOOL; stdcall;
	TAd03GetLastError = function(wLogSocket:WORD): DWORD; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pAd03GetVersion: TAd03GetVersion;
	pAd03Create: TAd03Create;
	pAd03Close: TAd03Close;
	pAd03GetResource: TAd03GetResource;
	pAd03SetMode: TAd03SetMode;
	pAd03StartSampling: TAd03StartSampling;
	pAd03StopSampling: TAd03StopSampling;
	pAd03GetSamplingStatus: TAd03GetSamplingStatus;
	pAd03GetData: TAd03GetData;
	pAd03GetLastError: TAd03GetLastError;

function _Ad03wGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Ad03wDllOpen: Boolean;
begin
	Result:=False;
	if hDLL=0 then begin
		hDLL:=LoadLibrary(AD03_DLL_NAME);
		if hDLL<>0 then begin
			if _Ad03wGetDllExportFunc=True then Result:=True
			else Ad03wDllClose;	// DLL֐擾ɎŝDLLN[Y
		end;
	end;
end;
//============================================================================
// 		DLL۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Ad03wDllClose: Boolean;
begin
	Result:=False;
	if hDLL<>0 then begin
		if True=FreeLibrary(hDLL) then begin
			hDLL:=0;
			Result:=True;
		end;
	end;
end;
//============================================================================
// 		DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Ad03wGetVersion(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): Boolean;
begin
  Result:=False;
  if hDLL<>0 then
    Result:=pAd03GetVersion(pdwDllVersion, pdwDriverVersion);
end;
//============================================================================
// 		޲̎gp錾
// 		pwLogSocket	 	gp޲̘_Ĕԍi[߲
//				hWnd 					VxDoүނ󂯎鳲޳
//				uWMBase 			oүނhcްlw
// ߂l  True
//				s False
//============================================================================
function Ad03wCreate(var pwLogSocket:WORD; hWnd:THandle; uWMBase:Integer): Boolean;
begin
  Result:=False;
  if hDLL<>0 then
  	Result:=pAd03Create(pwLogSocket, hWnd, uWMBase);
end;
//============================================================================
// 		޲J
// 		wLogSocket ޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Ad03wClose(wLogSocket:WORD): Boolean;
begin
  Result:=False;
  if hDLL<>0 then
  	Result:=pAd03Close(wLogSocket)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSocket	ؿ擾޲̘_Ĕԍ
//				pResInfo		ؿi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Ad03wGetResource(wLogSocket:WORD; pResInfo:PAD03RESOURCE): Boolean;
begin
  Result:=False;
  if hDLL<>0 then
  	Result:=pAd03GetResource(wLogSocket, pResInfo)
end;
//============================================================================
// 		ݸޓӰނ̐ݒ
// 		wLogSocket	Ӱނݒ肷޲̘_Ĕԍ
//				pMode				Ӱނi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Ad03wSetMode(wLogSocket:WORD; pMode:PAD03MODE): Boolean;
begin
  Result:=False;
  if hDLL<>0 then
  	Result:=pAd03SetMode(wLogSocket, pMode)
end;
//============================================================================
// 		ݸނ̽
// 		wLogSocket	Ă޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Ad03wStartSampling(wLogSocket:WORD): Boolean;
begin
  Result:=False;
  if hDLL<>0 then
  	Result:=pAd03StartSampling(wLogSocket)
end;
//============================================================================
// 		ݸނ̽į
// 		wLogSocket	į߂޲̘_Ĕԍ
// ߂l  True
//				s False
//============================================================================
function Ad03wStopSampling(wLogSocket:WORD): Boolean;
begin
  Result:=False;
  if hDLL<>0 then
  	Result:=pAd03StopSampling(wLogSocket)
end;
//============================================================================
// 		ݸ޽ð̎擾
// 		wLogSocket	ð擾邷޲̘_Ĕԍ
//				pcwNumData  ݸލςްi[̈ւ߲
//				pdwStatus		ݸޏԂ̽ði[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Ad03wGetSamplingStatus(wLogSocket:WORD; var pcwNumData:DWORD; var pdwStatus:DWORD): Boolean;
begin
  Result:=False;
  if hDLL<>0 then
  	Result:=pAd03GetSamplingStatus(wLogSocket, pcwNumData, pdwStatus)
end;
//============================================================================
// 		ݸް̎擾
// 		wLogSocket	ް擾邷޲̘_Ĕԍ
//				cwNumData 	ǂݏoް
//				pwData			ݸލςްi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Ad03wGetData(wLogSocket:WORD; cwNumData:DWORD; pwData:PAD03SMPLBUFF): Boolean;
begin
  Result:=False;
  if hDLL<>0 then
  	Result:=pAd03GetData(wLogSocket, cwNumData, pwData)
end;
//============================================================================
// 		װނ̎擾
// 		wLogSocket	װ޲̘_Ĕԍ
// ߂l װ
//============================================================================
function Ad03wGetLastError(wLogSocket:WORD): DWORD;
begin
	if hDLL=0 then Result:=AD03_ERR_WRAPDLL
	else Result:=pAd03GetLastError(wLogSocket)
end;
//----------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//----------------------------------------------------------------------------
function _Ad03wGetDllExportFunc: Boolean;
begin
	Result:=False;
	// Ad03GetVersion ̱ڽ擾
	pAd03GetVersion:=GetProcAddress(hDLL, 'Ad03GetVersion');
	if @pAd03GetVersion=nil then Exit;
	// Ad03Create ̱ڽ擾
	pAd03Create:=GetProcAddress(hDLL, 'Ad03Create');
	if @pAd03Create=nil then Exit;
	// Ad03Close ̱ڽ擾
	pAd03Close:=GetProcAddress(hDLL, 'Ad03Close');
	if @pAd03Close=nil then Exit;
	// Ad03GetResource ̱ڽ擾
	pAd03GetResource:=GetProcAddress(hDLL, 'Ad03GetResource');
	if @pAd03GetResource=nil then Exit;
	// Ad03SetMode ̱ڽ擾
	pAd03SetMode:=GetProcAddress(hDLL, 'Ad03SetMode');
	if @pAd03SetMode=nil then Exit;
	// Ad03StartSampling ̱ڽ擾
	pAd03StartSampling:=GetProcAddress(hDLL, 'Ad03StartSampling');
	if @pAd03StartSampling=nil then Exit;
	// Ad03StopSampling ̱ڽ擾
	pAd03StopSampling:=GetProcAddress(hDLL, 'Ad03StopSampling');
	if @pAd03StopSampling=nil then Exit;
	// Ad03GetSamplingStatus ̱ڽ擾
	pAd03GetSamplingStatus:=GetProcAddress(hDLL, 'Ad03GetSamplingStatus');
	if @pAd03GetSamplingStatus=nil then Exit;
	// Ad03GetData ̱ڽ擾
	pAd03GetData:=GetProcAddress(hDLL, 'Ad03GetData');
	if @pAd03GetData=nil then Exit;
	// Ad03GetLastError ̱ڽ擾
	pAd03GetLastError:=GetProcAddress(hDLL, 'Ad03GetLastError');
	if @pAd03GetLastError=nil then Exit;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result:=True;
end;

end.

