Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* axpad03w.bas                                                              *
'*                                                                           *
'* AXP-AD03                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/07/30                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AD03_DLL_NAME = "axpad03.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const AD03_ERR_WRAPDLL = -3    ' bp[֐G[

'*****************************************************************************
'*    axpad03.dll[h                                                *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wDllOpen() As Boolean

    Ad03wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AD03_DLL_NAME)
    If hDLL = 0 Then Exit Function

    If Ad03wGetDllExportFunc() = False Then
        Ad03wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Ad03wDllOpen = True

End Function

'*****************************************************************************
'*    axpad03.dllA[h                                            *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wDllClose() As Boolean

    Ad03wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Ad03wDllClose = False

End Function

'*****************************************************************************
'*    AXP-AD03 DLL,Vxd̃o[Wԍ擾                               *
'*    pdwDllVersion DLLo[Wԍi[AhX                  *
'*        pdwVxdVersion Vxdo[Wԍi[AhX                  *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wGetVersion(ByRef pdwDllVersion As Long, ByRef pdwVxdVersion As Long) As Boolean

    Ad03wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Ad03GetVersion(pdwDllVersion, pdwVxdVersion) = 0 Then Exit Function

    Ad03wGetVersion = True

End Function

'*****************************************************************************
'*    AXP-AD03̔Cӂ̃foCX̎gp錾                               *
'*    pwLogSocket gpfoCXi[AhX                     *
'*        hWnd      荞݂ƂbZ[W𑗂EBhEnh *
'*        uWMBase   bZ[Wԍ̃x[X                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wCreate(ByRef pwLogSocket As Integer, ByVal hWnd As Long, ByVal uWMBase As Long) As Boolean

    Ad03wCreate = False

    If hDLL = 0 Then Exit Function

    If Ad03Create(pwLogSocket, hWnd, uWMBase) = 0 Then Exit Function

    Ad03wCreate = True

End Function

'*****************************************************************************
'*    AXP-AD03̔Cӂ̃foCX̎gpJ                               *
'*    wLogSocket gpfoCX                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wClose(ByVal wLogSocket As Integer) As Boolean

    Ad03wClose = False

    If hDLL = 0 Then Exit Function

    If Ad03Close(wLogSocket) = 0 Then Exit Function

    Ad03wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSocket ׂfoCX                                          *
'*        pres     \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wGetResource(ByVal wLogSocket As Integer, ByRef pres As AD03RESOURCE) As Boolean

    Ad03wGetResource = False

    If hDLL = 0 Then Exit Function

    If Ad03GetResource(wLogSocket, pres) = 0 Then Exit Function

    Ad03wGetResource = True

End Function

'*****************************************************************************
'*    TvO[h̐ݒ                                           *
'*    wLogSocket ݒ肷foCX                                        *
'*        pcmode   [hݒf[^̃AhX                                *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wSetMode(ByVal wLogSocket As Integer, ByRef pcmode As AD03MODE) As Boolean

    Ad03wSetMode = False

    If hDLL = 0 Then Exit Function

    If Ad03SetMode(wLogSocket, pcmode) = 0 Then Exit Function

    Ad03wSetMode = True

End Function

'*****************************************************************************
'*    TvOJn                                                   *
'*    wLogSocket JnfoCX                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wStartSampling(ByVal wLogSocket As Integer) As Boolean

    Ad03wStartSampling = False

    If hDLL = 0 Then Exit Function

    If Ad03StartSampling(wLogSocket) = 0 Then Exit Function

    Ad03wStartSampling = True

End Function

'*****************************************************************************
'*    TvO~                                                   *
'*    wLogSocket ~foCX                                        *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wStopSampling(ByVal wLogSocket As Integer) As Boolean

    Ad03wStopSampling = False

    If hDLL = 0 Then Exit Function

    If Ad03StopSampling(wLogSocket) = 0 Then Exit Function

    Ad03wStopSampling = True

End Function

'*****************************************************************************
'*    TvOEXe[^X̎擾                                     *
'*    wLogSocket 擾foCX                                        *
'*        pcwNumData f[^obt@                                        *
'*        pdwStatus  Xe[^X                                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wGetSamplingStatus(ByVal wLogSocket As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Boolean

    Ad03wGetSamplingStatus = False

    If hDLL = 0 Then Exit Function

    If Ad03GetSamplingStatus(wLogSocket, pcwNumData, pdwStatus) = 0 Then Exit Function

    Ad03wGetSamplingStatus = True

End Function

'*****************************************************************************
'*    TvOς݃f[^̎擾                                       *
'*    wLogSocket 擾foCX                                        *
'*        cwNumData  vf[^                                            *
'*        pwData     f[^obt@                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Ad03wGetData(ByVal wLogSocket As Integer, ByVal cwNumData As Long, ByRef pwData() As Integer) As Boolean

    Ad03wGetData = False

    If hDLL = 0 Then Exit Function

    If Ad03GetData(wLogSocket, cwNumData, pwData(LBound(pwData))) = 0 Then Exit Function

    Ad03wGetData = True

End Function

'*****************************************************************************
'*    AXP-AD03̃G[R[h                                             *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Ad03wGetLastError(ByVal wLogSocket As Integer) As Long

    Ad03wGetLastError = AD03_ERR_WRAPDLL

    If hDLL = 0 Then Exit Function

    Ad03wGetLastError = Ad03GetLastError(wLogSocket)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Ad03wGetDllExportFunc() As Boolean

    Dim pFunc As Long

    Ad03wGetDllExportFunc = False

    ' Ad03GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03GetVersion")
    If pFunc = 0 Then Exit Function

    ' Ad03Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03Create")
    If pFunc = 0 Then Exit Function

    ' Ad03Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03Close")
    If pFunc = 0 Then Exit Function

    ' Ad03GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03GetResource")
    If pFunc = 0 Then Exit Function

    ' Ad03SetMode ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03SetMode")
    If pFunc = 0 Then Exit Function

    ' Ad03StartSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03StartSampling")
    If pFunc = 0 Then Exit Function

    ' Ad03StopSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03StopSampling")
    If pFunc = 0 Then Exit Function

    ' Ad03GetSamplingStatus ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03GetSamplingStatus")
    If pFunc = 0 Then Exit Function

    ' Ad03GetData ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03GetData")
    If pFunc = 0 Then Exit Function

    ' Ad03GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Ad03GetLastError")
    If pFunc = 0 Then Exit Function

    Ad03wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
